﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
/// <reference path="../../../../../Widgets/Wijmo/wijcandlestickchart/jquery.wijmo.wijcandlestickchart.ts"/>
var c1;
(function (c1) {
    var c1candlestickchart = (function (_super) {
        __extends(c1candlestickchart, _super);
        function c1candlestickchart() {
            _super.apply(this, arguments);
        }
        c1candlestickchart.prototype._create = function () {
            window["c1chart"].initChartExport();
            var self = this, o = self.options, content = o.hint.content, isContentFunc;

            self.hintContent = content;
            if (o.hint && o.hint.enable) {
                isContentFunc = $.isFunction(content);
                o.hint.content = function () {
                    return window["c1chart"].handleHintContents(content, this, self, function (data) {
                        var hintContents = data.hintContents, index = data.index;
                        if (hintContents && hintContents.length && index < hintContents.length) {
                            return self._fotmatTooltip(hintContents[index]);
                        }
                        return null;
                    });
                };
            }

            self.element.removeClass("ui-helper-hidden-accessible");
            _super.prototype._create.call(this);
        };

        c1candlestickchart.prototype._hasAxes = function () {
            return true;
        };

        c1candlestickchart.prototype.adjustOptions = function () {
            var _this = this;
            var self = this, o = self.options, axis = o.axis;
            o.hint.content = self.hintContent;
            if (this.timeUtil) {
                $.each(o.seriesList, function (i, series) {
                    if (series.data && series.data.x) {
                        $.each(series.data.x, function (j, val) {
                            if (typeof (val) === "number") {
                                series.data.x[j] = _this.timeUtil.getTime(val);
                            }
                        });
                    }
                });
            }
            if (axis && axis.x) {
                if (axis.x.autoMin) {
                    axis.x.min = null;
                }
                if (axis.x.autoMax) {
                    axis.x.max = null;
                }
            }
            if (axis && axis.y) {
                if ($.isArray(axis.y)) {
                    $.each(axis.y, function (i, yaxis) {
                        if (yaxis.autoMin) {
                            yaxis.min = null;
                        }
                        if (yaxis.autoMax) {
                            yaxis.max = null;
                        }
                    });
                } else {
                    if (axis.y.autoMin) {
                        axis.y.min = null;
                    }
                    if (axis.y.autoMax) {
                        axis.y.max = null;
                    }
                }
            }
        };
        return c1candlestickchart;
    })(wijmo.chart.wijcandlestickchart);

    c1candlestickchart.prototype.widgetEventPrefix = "c1candlestickchart";
    $.wijmo.registerWidget("c1candlestickchart", c1candlestickchart.prototype);
})(c1 || (c1 = {}));
