﻿/// <reference path="../../../../../Widgets/Wijmo/wijchartnavigator/jquery.wijmo.wijchartnavigator.ts"/>
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var c1;
(function (c1) {
    var c1chartnavigator = (function (_super) {
        __extends(c1chartnavigator, _super);
        function c1chartnavigator() {
            _super.apply(this, arguments);
        }
        c1chartnavigator.prototype._create = function () {
            var self = this, create = _super.prototype._create;

            // Add a timeout to make sure that all the target charts have been created !
            setTimeout(function () {
                self.element.removeClass("ui-helper-hidden-accessible");
                create.call(self);
            }, 0);
        };

        c1chartnavigator.prototype.adjustOptions = function () {
            var self = this;

            if (!self.targetChartInfos) {
                return;
            }
            $.each(self.targetChartInfos, function (idx, targetChartInfo) {
                var type = targetChartInfo.type, chartObj = targetChartInfo.chartObj;
                self._recoverTarget(targetChartInfo);

                chartObj.element["wijSaveState"](type, "adjustOptions");
            });
        };
        return c1chartnavigator;
    })(wijmo.chart.wijchartnavigator);

    c1chartnavigator.prototype.targetChartTypes = ["c1barchart", "c1candlestickchart", "c1linechart"];

    c1chartnavigator.prototype.widgetEventPrefix = "c1chartnavigator";

    $.wijmo.registerWidget("c1chartnavigator", $.wijmo.wijchartnavigator, c1chartnavigator.prototype);
})(c1 || (c1 = {}));
