/// <reference path="../../../../../Widgets/Wijmo/wijfileexplorer/jquery.wijmo.wijfileexplorer.ts"/>
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};

var c1;
(function (c1) {
    var $ = jQuery, defaultSearchPatterns = ["*.jpg", "*.jpeg", "*.gif", "*.png"];

    var c1fileexplorer = (function (_super) {
        __extends(c1fileexplorer, _super);
        function c1fileexplorer() {
            _super.apply(this, arguments);
        }
        c1fileexplorer.prototype._create = function () {
            var self = this;
            self._loadStates();
            _super.prototype._create.call(this);
        };

        c1fileexplorer.prototype._loadStates = function () {
            var self = this, states = self.options.innerStates;

            delete self.options.innerStates;
            self._treeInitData = states.treeInitData;
            self._clientID = states.clientID;
            self._uniqueID = states.uniqueID;

            self._data(states.currentFolderData);
            self._filterExpression(states.filterExpression);
            self._pageCount(states.pageCount);
            self._pageIndex(states.pageIndex);
            self._sortDirection(states.sortDirection);
            self._sortExpression(states.sortExpression);

            self._localization = self.options.localization;
            delete self.options.localization;
        };

        /** @ignore */
        c1fileexplorer.prototype._getTreeInitData = function () {
            return this._treeInitData;
        };

        /** @ignore */
        c1fileexplorer.prototype._enableAjax = function () {
            return true;
        };

        /** @ignore */
        c1fileexplorer.prototype.adjustOptions = function () {
            var self = this;
            self.options.innerStates = {
                filterExpression: self._filterExpression(),
                sortDirection: self._sortDirection(),
                sortExpression: self._sortExpression(),
                pageIndex: self._pageIndex()
            };
        };

        /** @ignore */
        c1fileexplorer.prototype._createAjaxAction = function (data, context, success, error) {
            var self = this, processResult = function (result) {
                return $.parseJSON(result);
            }, onSuccess = function (result) {
                if (success) {
                    success(processResult(result));
                }
            }, onError = function (result) {
                if (error) {
                    error(processResult(result));
                }
            };
            return function () {
                WebForm_DoCallback(self._uniqueID, c1common.JSON.stringify(data), onSuccess, context, onError, true);
            };
        };

        /** @ignore */
        c1fileexplorer.prototype._getDefaultSearchPattern = function () {
            return defaultSearchPatterns;
        };

        /** @ignore */
        c1fileexplorer.prototype._getLocalization = function () {
            return this._localization;
        };
        return c1fileexplorer;
    })(wijmo.fileexplorer.wijfileexplorer);
    c1.c1fileexplorer = c1fileexplorer;

    c1fileexplorer.prototype.widgetEventPrefix = "c1fileexplorer";

    c1fileexplorer.prototype.options = $.extend(true, {}, $.wijmo.wijfileexplorer.prototype.options, {
        searchPatterns: defaultSearchPatterns.slice()
    });

    $.wijmo.registerWidget("c1fileexplorer", $.wijmo.wijfileexplorer, c1fileexplorer.prototype);
})(c1 || (c1 = {}));
