/// <reference path="../../../../../Widgets/Wijmo/wijprogressbar/jquery.wijmo.wijprogressbar.ts"/>
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};

var c1;
(function (c1) {
    var $ = jQuery, hiddenCss = "ui-helper-hidden-accessible";

    var c1progressbar = (function (_super) {
        __extends(c1progressbar, _super);
        function c1progressbar() {
            _super.apply(this, arguments);
        }
        c1progressbar.prototype._setOption = function (key, value) {
            if (key === "startTaskButton" || key === "stopTaskButton") {
                this._bindEvents2Buttons();
            }

            $.wijmo.wijprogressbar.prototype._setOption.apply(this, arguments);
        };

        c1progressbar.prototype._create = function () {
            var self = this;

            //$.wijmo.wijprogressbar.prototype._create.apply(self, arguments);
            _super.prototype._create.call(this);
            self.element.removeClass("ui-helper-hidden-accessible");
            self._bindEvents2Buttons();
        };

        c1progressbar.prototype._bindEvents2Buttons = function () {
            var self = this, o = self.options, startButton, stopButton;

            if (o.startTaskButton !== "") {
                startButton = $("#" + o.startTaskButton);
                startButton.bind("click", function () {
                    self.startTask();
                    startButton.attr("disabled", "disabled");
                    stopButton.removeAttr("disabled");
                    return false;
                }).removeAttr("disabled");
            }

            if (o.stopTaskButton !== "") {
                stopButton = $("#" + o.stopTaskButton);
                stopButton.bind("click", function () {
                    self.stopTask();
                    startButton.removeAttr("disabled");
                    stopButton.attr("disabled", "disabled");
                    return false;
                }).attr("disabled", "disabled");
            }
        };

        c1progressbar.prototype._doPostBack = function (args) {
            var self = this, form = theForm, oldTarget = form.target, id = self.element.attr("id"), postBackEventReference = self.options.postBackEventReference;

            if (!form) {
                return;
            }

            form.target = "RunTaskTarget_" + id;

            //__doPostBack("C1ProgressBarRunTask_" + id, args);
            if (postBackEventReference) {
                c1common.nonStrictEval(postBackEventReference.replace("{0}", args));
            }
            form.target = oldTarget;
        };

        c1progressbar.prototype.startTask = function () {
            /// <summary>Start the progress</summary>
            this._setOption("animationOptions", { disabled: true });
            this._setOption("value", 0);
            this._doPostBack("Start");
        };

        c1progressbar.prototype.stopTask = function () {
            /// <summary>Stop the progress</summary>
            this._doPostBack("Stop|" + this.value());
        };
        return c1progressbar;
    })(wijmo.progressbar.wijprogressbar);
    c1.c1progressbar = c1progressbar;

    c1progressbar.prototype.widgetEventPrefix = "c1progressbar";

    c1progressbar.prototype.options = $.extend(true, {}, $.wijmo.wijprogressbar.prototype.options, {
        /// <summary>
        /// A value indicating the id of the button
        /// which starts a server side task.
        /// Default: "".
        /// Type: String.
        /// </summary>
        startTaskButton: "",
        /// <summary>
        /// A value indicates the id of the button
        /// which stops a server side task.
        /// Default: "".
        /// Type: String.
        /// </summary>
        stopTaskButton: ""
    });

    $.wijmo.registerWidget("c1progressbar", c1progressbar.prototype);
})(c1 || (c1 = {}));
